#!/bin/bash

ulimit -s unlimited

if [ "$1" == "no" ]; then
	echo " "
else
	./check.sh
	OUT=$?

	if [ $OUT -eq 1 ];then
   		echo "All dependencies are installed! We haven't check your hard drive type. If you are not using SSD, then the timing results may be affected. The experiment will run now..."
	else
   		echo "You are missing some dependendencies! Results may be affected."
   		read -p "Do you still want to continue? (y/n)?"
   		if [ $REPLY == "n" ]; then
			echo "Exiting..."
		exit 1
   		fi
	fi
fi


rm -r -f Host_BENEFICIARY
cd Experiment
cd MYTAR-CFLOW
rm -r -f Host_BENEFICIARY TEMP-* TransplantCode-* Temp/*
cd ..



# first generate the oracle files
cd MYTAR-CFLOW/TransplantCode && ./MYTAR_ORACLE.x 

cd ../../


./gentrans --seeds_file MYTAR-CFLOW/seed-1.in --compiler_options MYTAR-CFLOW/CFLAGS --host_target MYTAR-CFLOW/Host/cflow-1.4/src/output.c --donor_target MYTAR-CFLOW/Donor/append.c --donor_folder MYTAR-CFLOW/Donor/ --workspace MYTAR-CFLOW/ --core_function write_archive  --host_project MYTAR-CFLOW/Host


cd MYTAR-CFLOW
cp -r -f Host_BENEFICIARY ../../
rm -r -f Host_BENEFICIARY TEMP-* TransplantCode-* Temp/*
cd ../../


# Run test suites
./runTestSuites.sh
